# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# This file (IPcache.tcl) contains some tcl routines for saving data in an IP #
# cache.   This  is  because  on  some systems (e.g., AIX) the software can't #
# always get IP information, and there's no way for a mere user to inform the #
# nameserver of new systems. This gives us functionality like the host table, #
# but we can maintain it ourself, without root privileges  or  pleading  with #
# remote bureaucrats.                                                         #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Given a name and an IP address, stuff the address  in  our  cache  for  the #
# name.  The way we do this may change.                                       #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
proc CacheIPad {name ipad} {
	global D me
	set fname name-ipad/$name
	if [catch {open $fname w} fnum] {
		puts stderr "${me}/CacheIPad: Can't write \"$fname\" ($fnum)"
	} else {
		puts $fnum $ipad
		close $fnum
	}
}
