
NAME

  Map - display NDC process summary

SYNOPSIS

  Map <name>

KEYWORDS

  NDC process status

DESCRIPTION

  The  Map  program  creates  a  window that displays summary
  information about NDC processes that might be running on  the  given
  name.  The arguments are:

  <name>
    A map name, looked up in the "map" directory.  If omitted, the
    map called "Map" is the default; if there is no map/Map file, a
    blank map will be displayed (and the menu may be used to select
    a map).

MAP FILES

  The $NDCMONDIR/map directory contains the maps that can  be  displayed,
  one per file. A map file contains lines with (at least) five fields,
  such as:

    #type       name                X   Y icon
    NDS         duck               60 170 nds
    Interface   #ant.gte.com       60 200 aui
    Interface   #duck.gte.com      60 115 aui
    Workstation lizard             60  25 Xsun
    Interface   #lizard.gte.com    60  60 aui
    Computer    ract21            350  30 PowerPC

  The fields are:

  type
    If there is an executable program or script by this name, it  will
    be run when you use a <Double-1> or invoke the "details" menu item
    for a map object.  It will be passed  the  object's  name  on  its
    command line.

  name
    This is the name displayed on the map. If the name starts with '#'
    it is a "hidden" name that is normally not displayed.  The name is
    used as a lookup key for various purposes.  For instance, if there
    is  an  IP  address  associated  with the name (in the "name-ipad"
    directory), then the ICMPStat and SNMPStat  programs  will  return
    its  status,  which  will  be  used to color the icon red, blue or
    green.

  X Y
    These are the coordinates of the item in Map's picutre.  They  are
    measured in pixels from the upper-left corner.

  icon
    This must the name of a bitmap file in the icon directory, without
    its ".xbm" suffix.  Thus, for the icon "nds", there must be a file
    "icon/nds.xbm" which contains the icon.  You may  use  the  bitmap
    command to create these files..

INPUT

  The Map program takes most of its user input from the mouse, and
  also uses the keyboard for some purposes.

  The mouse buttons are used as follows:

  <Button-1>
  <Button-3>
    Both of these currently produce the same menu, a list of  actions
    that  may be performed on the item.  The first "detail" menu item
    attempts to run the type field as a command.  Such commands  have
    been  provided  for several types:  Computer and Workstation open
    the AddrInfo window for configuring address information. The NDC,
    NDS  and NDI types all run NDCprocesses, giving a process summary
    for the node.  For items of type Map, the corresponding map  will
    be loaded if there is a map/name file for it.

  <Double-1>
    This isn't currently used for much by this version  of  Map.   The
    icon's  background  color  will change, and there are a few places
    where information will be taken from  the  last-selected  item  to
    fill in fields in subwindows.

  <Button-2>
    This is used to move items around on the map.  Point at  an  item,
    and  hold  down  button  2;  the  item  will  move around with the
    pointer.  When you release button 2, the item will be left in  its
    new  position.   Note that this only affects the in-memory copy of
    the map; to save the new position(s), you must use  the  "File  ..
    Save" menu item.

  <Delete>
    If pressed over an icon or link, that item or link will be deleted
    from the in-memory copy of the map. To make the deletion permanent
    you need to use the "File ..  Save" menu command.

  <Help>
    There is the start of a generalized Help feature:  If you point at
    an  item  in  the picture (including the map background), the help
    window will be opened and filled with information for  that  item.
    At present, this doesn't work for all items. If you wish to create
    a help entry for item xyz, put it in the  file  help/Map/xyz,  and
    the Help button will find it.

  <Return>
    This is rarely used; it sometimes functions as a "do  it"  command
    in a few input fields in some sub-windows.  When this works, it is
    documented in the description of the particular field.

  1, 2
    These two number keys are used for adding links to the map.  Point
    at one item and press 1, then point at another item and press 2; a
    line connecting them will appear.  This only affects the in-memory
    copy  of  the  map;  to save the new position(s), you must use the
    "File ..  Save" menu item.


OPTIONS

  None.

ENVIRONMENT

  NDCDIR
    The NDC working directory; the default  is  /ndc,  or  "."  if
    there is no ndc pseudo-user.

  NDCMONDIR
    The NDC monitor directory; the default is /ndc/mon, or "."  if
    there is no ndc pseudo-user.

  D_Map
    The debug level.  If defined, it should be a single digit; the log
    info goes to standard output.

FILES

  $NDCMONDIR/map/<name>
    lists the items in the map.

  $NDCMONDIR/link/<name>
    the links between map items.

  $NDCMONDIR/icon/<name>
    the icon files, of type ".xbm". See the bitmap command for further
    information on creating these files.

  $NDCMONDIR/background/<name>
    For a map xyz, if there is a bitmap file "background/xyz.xbm",  it
    will  be  used  as a background picture for the map.  If this file
    doesn't exist, the background will  the  the  X  server's  default
    background color.

  $NDCMONDIR/name-ipad/<name>
    If this file exists, its contents will be used as  an  IP  address
    for the given name.

  $NDCMONDIR/name-comm/<name>
    If this file exists,  its  contents  will  be  used  as  the  SNMP
    community string in requests to that node.

LOGFILE
  See D_NDCprocess above.

DEBUGGING
  See D_NDCprocess above.

SEE ALSO
  Map, NDCprocess, NDCprocesses, NEtrend, bitmap.

BUGS
  The Map program is still in a "prototype" stage, and can be expected
  to change as we think of improvements.

AUTHOR
  John Chambers <jmc0@gte.com>

