# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# This routine is called when the status routine for type t looks at a  given #
# node  n.   We  color  the  border  of  the  icon  and  its label.  When the #
# status-query phase terminates,  mapstat  will  eliminate  the  border.   We #
# maintain  a border icon for each of the three status checks:  ICMP, NDC and #
# SNMP, so there can be up to 3 icons with a colored border.                  #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
proc Mark {t n} {
	global C D W me n2p n2l mark mpic mlbl

	if [info exists mark($t)] {
		if {$D>1} {puts "$me/Mark: mark($t) was $mark($t)"}
	}
	if ![info exists mpic($t)] {
		if {$D>2} {puts "$me/Mark: Create mpic($t) ..."}
		set mpic($t) [.map create rectangle 0 0 0 0 -width $W(mark) -outline $C(mark$t)]
		if {$D>2} {puts "$me/Mark: Created mpic($t)=$mpic($t)"}
	}
	if [info exists n2p($n)] {
		if {$n2p($n) != {}} {
			if {$D>2} {puts "$me/Mark: coords $mpic($t) [.map bbox $n2l($n)]"}
			eval .map coords $mpic($t) [.map bbox $n2p($n)]
			eval .map lower  $mpic($t) $n2p($n)
		} else {
			if {$D>2} {puts "$me/Mark $t $n coords $mpic($t) 0 0 0 0"}
			eval .map coords $mpic($t) 0 0 0 0
		}
	}
	if ![info exists mlbl($t)] {
		if {$D>2} {puts "$me/Mark: Create mlbl($t) ..."}
		set mlbl($t) [.map create rectangle 0 0 0 0 -width $W(mark) -outline $C(mark$t)]
		if {$D>2} {puts "$me/Mark: Created mlbl($t)=$mlbl($t)"}
	}
	if [info exists n2l($n)] {
		if {$n2l($n) != {}} {
			if {$D>2} {puts "$me/Mark: coords $mlbl($t) [.map bbox $n2l($n)]"}
			eval .map coords $mlbl($t) [.map bbox $n2l($n)]
			eval .map lower  $mlbl($t) $n2l($n)
		} else {
			if {$D>2} {puts "$me/Mark $t $n coords $mlbl($t) 0 0 0 0"}
			.map coords $mlbl($t) 0 0 0 0
		}
	}
	set mark($t) $n
	if {$D>1} {puts "$me/Mark: mark($t) now $mark($t)"}
	if {$D} {flush stdout}
	update
}
