if ![info exists getcmd] {set getcmd snmpGet}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# This routine fetches the node's status, and leaves it in the global
# nodeOperStatus variable.
proc GetNodeStat {} {
	global C D ipad comm ndcport nodeOperStatus getcmd me
	if {$D>0} {puts "GetNodeStat: ipad=\"$ipad\""}
	if ![info exists ndcport] {set ndcport -P6161}
	set cmd "$getcmd $ipad $comm -sw $ndcport nodeOperStatus.0"
	if {$D>0} {puts "GetNodeStat: $cmd"}
	set gstat [catch {eval exec $cmd} x]
	if {$D>0} {puts "GetNodeStat: \"$cmd\" gave status $gstat"}
	if {$gstat} {
		if {$D>0} {puts "GetNodeStat: $getcmd ... nodeOperStatus.0 failed"}
		set x "set nodeOperStatus 0"
		if {$D>0} {puts "GetNodeStat: Got \"$x\""}
	} else {
		if {$D>0} {puts "GetNodeStat: x=\"$x\""}
		eval $x
	}
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Here is a clone of the variable-tracing routine from the  book.   This  one #
# handles  a new nodeOperStatus value, by recalculating the ndstat value that #
# is displayed.                                                               #
#    trace variable nodeOperStatus w NewNodeStat                              #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
proc NewNodeStat {name p nd} {
	global C D .vstat nodeOperStatus ndstat me
	upvar $name x
	if {$D>1} {puts "Set $name to \"$x\""}
	set ndstat [SymVal nodeOperStatus $nodeOperStatus]
	if {$D>1} {puts "Set ndstat to \"$ndstat\""}
#	ClrNdSt
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# This routine sets the node status to s.  We use the snmpTest subprocess to
# send the message, so the snmpTest.w package must be loaded.
proc SetNodeStat {s} {
	global D me
	if {$D>1} {puts "SetNodeStat: Set node status to $s"}
	set f [snmpTestProc]
	if {$D>1} {puts "SetNodeStat: Send \$S\nnodeAdminStatus.0\ni\n$s\n"}
	puts $f {$S}
	puts $f nodeAdminStatus.0
	puts $f i
	puts $f $s
	puts $f {}
	flush $f
	after 5000 GetNodeStat
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# This routine sets the node status to s.  We use the snmpTest subprocess to
# send the message, so the snmpTest.w package must be loaded.
proc SetNodeMsg {} {
	global D me nodeMessage
	if {$D>1} {puts "SetNodeMsg: Set node msg to \"$nodeMessage\""}
	set f [snmpTestProc]
	if {$D>1} {puts "SetNodeMsg: Send \$S\nnodeMessage.0\ni\n$s\n"}
	puts $f {$S}
	puts $f nodeMessage.0
	puts $f s
	puts $f $nodeMessage
	puts $f {}
	flush $f
	after 5000 GetNodeStat
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Here's a little routine to create a menu of nodeOperStatus values. The call #
# should look like:                                                           #
#   menubutton .f.b -textvariable ndstat -menu .f.b.menu                      #
#   StatMenu .f.b.menu                                                        #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
proc StatMenu {m} {
	global D me nodeOperStatus me
	if {$D>0} {puts "Status menu $m ..."}
	menu $m
	foreach i {0 1 2 3} {
		set s [exec symval nodeOperStatus $i]
		if {$D>0} {puts "$me/StatMenu: i=$i s=\"$s\""}
		$m add command -label "$i=$s" -command "SetNodeStat $i"
	}
	trace variable nodeOperStatus w NewNodeStat
	return $m
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Given a variable name and a numeric value, this routine returns  either  or #
# both of the numeric and symbolic values (from help/$var). The form returned #
# depends of the global variables $numvals and $symvals, which should be 0/1. #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
proc SymVal {var val} {
	global C D numvals symvals me
	if ![info exists numvals] {set numvals 1}
	if ![info exists symvals] {set symvals 1}
	if {$D>1} {puts "SymvVal: symvals=$symvals numvals=$numvals"}
	if {$symvals} {
		if {$D>1} {puts "SymvVal: exec symval $var $val"}
		set s [exec symval $var $val]
		if {$D>1} {puts "SymvVal: s=\"$s\""}
		if {$numvals} {return "$val=$s"}
		return $s
	}
	if {$numvals} {return $val}
	return "?"
}
