
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
## Collect and display sample data for a range of indices.   Actually, #
## we  only  collect  the  data if get==1; when called with get==0, we #
## just redraw the graph for the current values. Thus this routine can #
## be called to update a portion of the graph with new data (as Update #
## does), or it can be used to totally redraw the graph with old  data #
## (as ReConfig does).                                                 #
##                                                                     #
## An important piece of trivia here: minutes are in the range [0,59], #
## and tcl likes this as subscripts. But SNMP has trouble dealing with #
## zero  as  an instance, so the SNMP instances have the range [1,60]. #
## If you don't keep this straight, you will get rather confused.      #
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
#proc Sample {get h1 m1 h2 m2} {
#	global NWx NWy SEx SEy
#	global .g bar Clr clr cols maxCol comm D getcmd ipad mcurr prt barw poll 
#	global Sx Sy Tx Ty varlist vars curNE
#	global minHour curHour incHour maxHour minMin curMin incMin maxMin 
#	set c2 [expr 1 - [set c1 $clr]]
##	if {$D>1} {puts "Sample: $get h1=$h1 m2=$m2 c1=$c1 c2=$c2 mcurr=$mcurr NOT DONE"}
##	return 0
#	set n $curNE
#	for {set h $h1} {$h <= $h2} {incr h $incHour} {
#		for {set m $m1} {$m <= $m2} {incr m $incMin} {
#			set i "${n}.${h}.${m}"	;# Instances for this sample.
#			set j [hm2i $h $m]	;# Subscript for this sample.
#			set s "${n},${h},${m}"	;# Instances for this sample.
#			if {$D>1} {puts "Sample: varlist=\"$varlist\""}
#			for {set v 0} {$v < $vars} {incr v} {
#				set A [lindex $varlist $v]
#				if {$D>1} {puts "Sample: A=\"$A\""}
#				global $A
##				if {$get > 0 || ![info exists ${A}($s)]} 
#				if {$get > 0} {
#					if {$D>1} {puts "Sample: $getcmd $ipad $comm -sw $prt $A.$i"}
#					if [set stat [catch {exec $getcmd $ipad $comm -sw $prt $A.$i} info]] {
#						if {$D>1} {puts "Sample: Got no data for $A.$i from $ipad"}
#						if {$D>1} {puts "Sample: $getcmd returned status $stat"}
#						if {$D>1} {puts "Sample: $getcmd returned value \"$info\""}
#					} else {
#						if {$D>1} {puts "Sample: Got \"$info\""}
#						eval $info
#					}
#				}
#				if {$D>1} {puts "Sample: Variable ${A}($s): ..."}
#				upvar #0 ${A}($s) V
#				if [info exists ${A}($s)] {} else {set ${A}($s) 0}
#				if {$D>1} {puts "Sample: Variable ${A}($s): \"$V\""}
#				set NWx($s,$v) [expr $Sx($j) + ($v * $barw) + 1]
#				set NWy($s,$v) [expr $Sy($j) - 2 - [scale $V]]
#				set SEx($s,$v) [expr $Sx($j) + (($v + 1) * $barw) + 1]
#				set SEy($s,$v) [expr $Sy($j) - 2]
#				set c [hmclr $h $m]
#				if {$D>1} {puts "Sample: i=$i mcurr=$mcurr c=$c c1=$c1 c2=$c2"}
#				if [info exists bar($s,$v)] {
#					if {$D>0} {puts "Sample: bar $s,$v is [.g coords $bar($s,$v)]"}
#					if {$D>1} {puts "Sample: bar $s,$v to $NWx($s,$v) $NWy($s,$v) $SEx($s,$v) $SEy($s,$v)"}
#					.g coords $bar($s,$v) $NWx($s,$v) $NWy($s,$v) $SEx($s,$v) $SEy($s,$v)
#					if {$D>1} {puts "Sample: itemconfigure $bar($s,$v) -fill $Clr($v,$c)"}
#					.g itemconfigure $bar($s,$v) -fill $Clr($v,$c)
#				} else {
#					if {$D>1} {puts "Sample: bar $s,$v at $NWx($s,$v) $NWy($s,$v) $SEx($s,$v) $SEy($s,$v)]"}
#					set bar($s,$v) [.g create rectangle \
#						$NWx($s,$v) $NWy($s,$v) $SEx($s,$v) $SEy($s,$v) -fill $Clr($v,$c)]
#					if {$D>1} {puts "Sample: Created item bar($s,$v)=$bar($s,$v)"}
#				}
#			}
#			update
#		}
#	}
#	flush stdout
#}

