# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Get details about a given time slot.  The BarMenu routine passes us #
# the  hour,  minute and variable number for the bar, but we probably #
# don't need all of this.                                             #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
proc ShowBar {h m v} {
	global B C D R .g .bm .bd bx myname node comm incMin xabs yabs
	global neHMAlarm neCurr neIndex neHMMessage vars showpid
	global neHMDeviation neHMStdDev neHMOutlier
	if {$D} {puts "ShowBar: h=$h m=$m v=$v."}
	set w .bd($h,$m)
	if [info exists bx($h,$m)] {	;# Have we produced this window before?
		if {$D} {puts "ShowBar: bx($h,$m) is $bx($h,$m)"}
		if {$bx($h,$m) != $neIndex} {	;# Was it for the same NE?
			if {$D} {puts "ShowBar: neIndex is $neIndex"}
			if [winfo exists $w] {		;# If not, does window exits?
				if {$D} {puts "ShowBar: $w must be destroyed."}
				destroy $w				;# If so, forget it and make new one.
	}	}	}
	if [winfo exists $w] {	;# Now, is there a window for this sample?
		raise $w			;# If so, make sure it is visible.
	} else {				;# If not, create one.
		if {$D} {puts "ShowBar: exec NEgraphData \"$myname\" \"$node\" \"$comm\" \"$neIndex\" \"$h\" \"$h\" \"$incMin\""}
		set showpid [exec NEgraphData $myname $node $comm $neIndex $h $h $incMin &]
		if {$D} {puts "ShowBar: toplevel .bd -geometry +${xabs}+${yabs}"}
		toplevel $w
		set bx($h,$m)w $neIndex	;# Note the NE index associated with this one.
		wm geometry $w +$xabs+$yabs
		wm title $w "$neCurr at $h:$m"

		set type entry

		frame $w.fCurrRecRate -bd $B -relief $R
		label $w.lCurrRecRate -bd $B -relief $R -width 12 -anchor e -text CurrRecRate:
		if ![info exists  $vars(1)($neIndex,$h,$m)] {set $vars(1)($neIndex,$h,$m) 0}
		eval $type $w.vCurrRecRate -bd $B -relief $R -width 0 -textvariable $vars(1)($neIndex,$h,$m)
		pack  $w.lCurrRecRate -in $w.fCurrRecRate -side left
		pack  $w.vCurrRecRate -in $w.fCurrRecRate -side right
		pack  $w.fCurrRecRate -in $w -side top -expand 1 -fill x

		frame $w.fHistRecRate -bd $B -relief $R
		label $w.lHistRecRate -bd $B -relief $R -width 12 -text HistRecRate:
		if ![info exists  $vars(2)($neIndex,$h,$m)] {set $vars(2)($neIndex,$h,$m) 0}
		eval $type $w.vHistRecRate -bd $B -relief $R -width 0 -textvariable $vars(2)($neIndex,$h,$m)
		pack  $w.lHistRecRate -in $w.fHistRecRate -side left
		pack  $w.vHistRecRate -in $w.fHistRecRate -side right ;# -expand 1 -fill x
		pack  $w.fHistRecRate -in $w -side top -expand 1 -fill x

		frame $w.fAlarm -bd $B -relief $R
		label $w.lAlarm -bd $B -relief $R -width 12 -anchor e -text Alarm:
		eval $type $w.vAlarm -bd $B -relief $R -width  0 -textvariable neHMAlarm($neIndex,$h,$m)
		pack  $w.lAlarm -in $w.fAlarm -side left
		pack  $w.vAlarm -in $w.fAlarm -side right 
		pack  $w.fAlarm -in $w -side top -expand 1 -fill x

		frame $w.fMessage -bd $B -relief $R
		label $w.lMessage -bd $B -relief $R -width 12 -anchor e -text Message:
		eval $type $w.vMessage -bd $B -relief $R -width 0 -textvariable neHMMessage($neIndex,$h,$m)
		pack  $w.lMessage -in $w.fMessage -side left
		pack  $w.vMessage -in $w.fMessage -side right
		pack  $w.fMessage -in $w -side top -expand 1 -fill x

		frame $w.fDeviation -bd $B -relief $R
		label $w.lDeviation -bd $B -relief $R -width 12 -anchor e -text Deviation:
		eval $type $w.vDeviation -bd $B -relief $R -width 0 -textvariable neHMDeviation($neIndex,$h,$m)
		pack  $w.lDeviation -in $w.fDeviation -side left
		pack  $w.vDeviation -in $w.fDeviation -side right
		pack  $w.fDeviation -in $w -side top -expand 1 -fill x

		frame $w.fStdDev -bd $B -relief $R
		label $w.lStdDev -bd $B -relief $R -width 12 -text StdDev:
		eval $type $w.vStdDev -bd $B -relief $R -width 0 -textvariable neHMStdDev($neIndex,$h,$m)
		pack  $w.lStdDev -in $w.fStdDev -side left
		pack  $w.vStdDev -in $w.fStdDev -side right
		pack  $w.fStdDev -in $w -side top -expand 1 -fill x

		frame $w.fOutlier -bd $B -relief $R
		label $w.lOutlier -bd $B -relief $R -width 12 -anchor e -text Outlier:
		eval $type $w.vOutlier -bd $B -relief $R -width 0 -textvariable neHMOutlier($neIndex,$h,$m)
		pack  $w.lOutlier -in $w.fOutlier -side left
		pack  $w.vOutlier -in $w.fOutlier -side right
		pack  $w.fOutlier -in $w -side top -expand 1 -fill x
	}
}
