# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
#    &datum(line,f1,f2,...)                                                   #
# Write  one  line  to one or more files.  Actually, we write the line to the #
# first file, and then link it to the rest, so they must be on the same  file #
# system.  Note also that we first unlink each file, so the data will be in a #
# "new" file.  We return 1 for success in  writing  the  first  file,  0  for #
# failure.   At  present, we don't notice failures to link to the rest of the #
# files in the list, so 1 only means that f1 was  written  successfully.   If #
# this is a problem, we can consider other return values to show errors.      #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub datum {
	local($line,$f1) = @_;
	unlink($f1);	# Undo any multiple links.
	if (open(X,">$f1")) {
		print X $line;	# Write the line to the first file.
		close X;		# Mainly to force a flush.
	} else {
		print STDERR "# $$: Can't write $f1 [$!]\n";
		return 0;	# Disaster.
	}
	splice(@_,0,2);			# Delete line and first file name.
	foreach $f2 (@_) {		# Run thru the rest of the files.
		if ($f2) {			# Paranoia.
			unlink($f2);	# Get rid of the old file.
			link($f1,$f2);	# Link it to the "current" sample.
		}
	}
	1;
}
1;
