

NAME

  AddrInfo - display address information about a node.

SYNOPSIS

  AddrInfo <node> [<agent> [<community>]]

KEYWORDS

  SNMP system interface

DESCRIPTION

  The AddrInfo program creates a window  that  displays  the  assorted
  addressing information about a remote system.  You can modify any of
  the fields, and press a button to save the information  in  the  NDC
  cache.


  The window displays the following fields:

  Node name
    This is the <node> from the command line.

  IP address
    This  is  looked  up  first  in  the NDC cache, and then the local
    nameserver. If neither can decode the <node> name, then this field
    is blank.

  SNMP agent
    This may be different from the <node>; for names not known to  the
    local nameserver, it

  Host name
    This is what the system calls itself.  If not in  the  cache,  the
    value may be gotten via an SNMP request for sysName.

  Community
    The SNMP community string, "public" by default.


  The "Save" button causes the information to be written  to  the  NDC
  address  cache.  The "SNMP Info" button invokes the SNMPInfo program
  to show further details.


  The command-line arguments are:

  <node>
    A hostname or IP address for the remote system. This may be any of
    the   hostnames  or  IP  addresses  associated  with  any  of  the
    computer's network interfaces.

  <agent>
    A hostname or IP address to be used for SNMP queries.  If omitted,
    the <node> will be used; if this doesn't work, no SNMP information
    will be accessed.

  <community>
    The SNMP community string to use (public by default)

OPTIONS

  None.

ENVIRONMENT

  D_AddrInfo
    The debug level.  If defined, it should be a single digit; the log
    info goes to standard output.

FILES

LOGFILE
  See D_AddrInfo above.

DEBUGGING
  See D_AddrInfo above.

SEE ALSO
  gethostbyaddr(3)

BUGS
  Some agents don't implement sysName; for such systems, there may be no
  way to determine what the system calls itself.

AUTHOR
  John Chambers <jmc0@gte.com>

