

NAME

  SNMPInfo - display SNMP system and interface information

SYNOPSIS

  SNMPInfo <node> [<community>]

KEYWORDS

  SNMP system interface

DESCRIPTION

  The  SNMPInfo  program creates a window that displays the system and
  interface information from SNMP MIB-I and MIB-II.  The window  comes
  up  showing  some  basic information about the system, including its
  sysName and IP address.  There are two buttons that you can push:

  Query Interface Status
    This  button  fills in a table of the system's network interfaces,
    giving the name, status, IP address and hostname  for  each.   The
    hostname is determined by passing the IP address to gethostbyaddr,
    so the name is usually whatever your local nameserver has for  the
    address.

  Query System Status
    This button sends queries for the SNMP system group, and  displays
    the values. What you get will be determined by what is implemented
    in the agent.  Some  SNMP  agents  only  implement  a  few  system
    variables;  others  implement  them  all.   It  is  common for the
    sysDescr to be a multi-line value; SNMPInfo will do  its  best  to
    display the entire value.

  The command-line arguments are:

  <node>
    A hostname or IP address for the remote system. This may be any of
    the   hostnames  or  IP  addresses  associated  with  any  of  the
    computer's network interfaces.

  <community>
    The SNMP community string to use (public by default)

OPTIONS

  None.

ENVIRONMENT

  D_SNMPInfo
    The debug level.  If defined, it should be a single digit; the log
    info goes to standard output.

FILES

LOGFILE
  See D_SNMPInfo above.

DEBUGGING
  See D_SNMPInfo above.

SEE ALSO
  gethostbyaddr(3)

BUGS
  Some agents don't implement sysName; for such systems, there may be no
  way to determine what the system calls itself.

AUTHOR
  John Chambers <jmc0@gte.com>

