


SNMPWALK(1)              USER COMMANDS                SNMPWALK(1)



NAME
  snmpWalk - communicates with a network entity using  SNMP  GET  Next
  Requests.

SYNOPSIS
  snmpWalk host community [variable-name]

DESCRIPTION
  Snmpwalk is an SNMP application that uses GET NEXT Requests to query
  for a tree of information about a network entity.

  The  host  specification  may  be  either a host name or an internet
  address specified in "dot notation"

  The community specifies the community name for the transaction  with
  the remote system.

  A variable may also be given on the  command  line.   This  variable
  specifies  which  portion  of  the  object  identifier space will be
  searched using GET NEXT Requests. All variables in the subtree below
  the  given  variable  are  queried and their values presented to the
  user.  Each variable name  is  given  in  the  format  specified  in
  variables(5).

  If the "variable-name" argument is not present, snmpWalk will search
  the whole Internet MIB.

  For example

  snmpWalk netdev-kbox.cc.cmu.edu public system

  will retrieve the variables sysDescr.0 and sysObjectID.0 and
  sysUpTime.0:

  Name: system.sysDescr.0
  OCTET STRING- (ascii):   Kinetics FastPath2

  Name: system.sysObjectID.0
  OBJECT                                           IDENTIFIER:
  .iso.org.dod.internet.private.enterprises.CMU.sysID.CMU-KIP

  Name: system.sysUpTime.0
  Timeticks: (2291082) 6:21:50

  If the network entity has an error processing the request packet, an
  error packet will be returned and a message will be  shown,  helping
  to pinpoint why the request was malformed.

  If  the  tree search causes attempts to search beyond the end of the
  MIB, a message will be displayed:

  End of MIB.

  Adding a "-d" to the argument list will  cause  the  application  to
  dump input and output packets.

SEE ALSO
  variables(5), RFC 1065, RFC 1066, RFC 1067

