
AGENT(1)                    USER COMMANDS                      AGENT(1)

NAME
   agent - SNMP agent background daemon

SYNOPSIS
   agent [options]

DESCRIPTION
   Agent is an SNMP agent program that runs  as  a  background  daemon
   process  on  a  Unix  system.   It opens the SNMNP port (udp/161 by
   default) and waits for SNMP requests to arrive. If a request can be
   satisfied, it sends an SNMP reply message back to the originator of
   the request.

   This program may be linked to various names, in its incarnations as
   agents  for  various  projects.   It  has  been  known  as "snmpd",
   "ndcsnmpd", "ndcagent", "spanetd", etc.  The only way in which  its
   name  is  used  is to guess the name of its config file.  If called
   "foo", its preferred  config  file  names  will  be  "foo.cfg"  and
   "foo.conf".   If  these  don't  exist,  the  names "snmpd.conf" and
   "/etc/snmpd.conf" will be tried.

   Although this agent has various options, it is designed to use  the
   same  sort  of  defaults  as  most other Unix SNMP agents, and will
   usually run correctly with no options or arguments at all. Snmpd is
   designed  to  be  started as part of the system's startup, from the
   /etc/rc* scripts or via inetd or inittab.  For testing purposes, it
   has  a  number of optional command-line arguments, and it will also
   use several variables from the environment, if they are defined. It
   also reads from a config file if it is present.

   Unlike some other SNMP agents, this program  does  NOT  put  itself
   into  the  background by the usual fork+exit method.  The reason is
   that this agent can be run from inetd, and  if  it  were  to  exit,
   inetd  would  start up a second (and third and ...) copy.  Starting
   the agent from inetd is the recommended approach, as this  lets  it
   run  without  root  privileges, and will guarantee restarting if it
   fails (or not starting it at all if there are no SNMP requests).

   In normal operation, most SNMP agents must be run as root  so  that
   UDP  port  161  can be opened.  Alternatively, you may use inetd to
   open the port, in which case snmpd may be run  as  an  unprivileged
   user.   For  testing,  a  port other than 161 may be used, and root
   permissions  are  not  needed  at  all.   This  implies  that  your
   application   programs  must  also  have  a  way  of  specifying  a
   non-standard SNMP port.

   This agent reads from /dev/kmem, and will totally fail if this file
   isn't readable.

   This version of snmpd has been extended to include support for  the
   GTE  SPANet  MIB and the GTE NDC Monitor and Control package.  When
   the SPANet code is enabled, data for the SPANet MIB is obtained  by
   exchanging messages with the CM (Control Module) process. Thus this
   agent is a proxy SNMP agent. The NDC package makes extensive use of
   various  subdirectories  (client,  df,  ne, proc, etc.), and trusts
   that some mechanism is in place to run the programs that create the
   files  in  these  directories.  The "snmp" startup script is a good
   place to run some of these programs (wuch as  snmpTrapd);  cron  is
   another good way to run others.

   For  versions  that  don't  include  the  SPANet  MIB,  ignore  any
   references to "CM".

OPTIONS
   Options may start with '-' or '+'.  For  some  options,  '-'  means
   disable  and  '+'  means  enable.   For  others,  this  concept  is
   irrelevant, and it doesn't matter which flag character you use.  In
   the  descriptions  below,  '-'  means  that  the  flag character is
   irrelevant; '+' means that it is significant.

   After the flag char, options have with a single letter,  which  may
   be  upper  or  lower  case,  possibly  followed  immediately  by  a
   parameter.

      -3
      +3
      -4
      +4

   These enable or enable the use  of  Release  3  and  Release  4  CM
   messages.   The  default  is to have both enabled.  This means that
   snmpd will send requests in both formats, and  will  use  whichever
   responses it gets back.  If either is disabled, snmpd will not send
   that kind of requests.  The current version will still use whatever
   replies  the  CM  sends  back,  however.   Note that the cmsim test
   program has these same options, to simplify testing of  mixed-level
   installations.


      +c
      -c

   These enable/disable the periodic checking of the CM's status. This
   can  be  useful  to prevent delays for variables that need the CM's
   status; during testing,  it's  generally  better  to  not  do  this
   checking.  Default:  -c.

      -D<l><file>
      +D<l><file>
      %D<l><file>

   These all set the debug level to  <l>  (a  single  digit)  and  the
   output log file to <file>.  See the DEBUGGING section below.

      +e

   This tells the agent to return the "no  such  variable"  error  (2)
   when  it  can't  get  data  for  a  variable because there's no GET
   routine in its MIB table.   The  default  for  variables  that  are
   present but not yet implemented is NODATA (998).

      -H<c>

   This sets the hexdump format to the character <c>.  See the HEX_FMT
   environment variable below for details.

      +I

   This tells snmpd to try to process each message as it is  received.
   This is the original behavior of the CMU code.  The default (-I) is
   to read and queue all incoming messages, and then to process  them.
   For  requests that require data from the CM, this option may result
   in much slower responses.

      +M

   This produces a symbolic dump of the MIB table during startup. "-M"
   does nothing at all (but might be useful for documentation).

      -N
      +N

   This tells the agent how to treat variables that  are  in  its  MIB
   table  but  for which there isn't (yet) a GET routine:  +N means to
   return a NULL value; -N means to return the SNMP "no such variable"
   error code, 2.

      +NXTpvc
      +NXTrt
      +NXTvpc

   These enable the GET-NEXT operation for the corresponding groups of
   MIB  variables.   Depending  on  the version of the CM, this may be
   risky for these variables, and should only be used during  testing.
   However, in released versions of the agent, the defaults should all
   be '+' (i.e., enabled).  The groups affected may  change  with  new
   releases of the agent.

      -p<number>

   This specifies a UDP port number to be used for SNMP messages.  See
   the SNMP_PORT variable below.

      -SET
      +SET

   This says whether to implement  read-only  checking  for  SNMP  SET
   operations.   -SET  disables  SET  operations for all variables not
   labelled read-write; +SET tells  snmpd  to  disregard  the  "ACCESS
   read-only"  MIB  clause  and  allow SETs for any variables that are
   settable (i.e., the ones which snmpd knows how to  set).   This  is
   independent of the set-community mechanism; clients must still have
   an  acceptable  set-community-name  and  set-community-addr  to  be
   allowed to perform SET operations.

      %varName

   An option consisting of a '%' and a MIB variable name will suppress
   the variable.  This is primarily for use during testing, when there
   are problems with the CM's handling of some variables.

      +u

   This tells the agent to return the "not  implemented"  error  (999)
   when  it  can't  get  data  for  a  variable because there's no GET
   routine in its MIB table.

      +v

   This tells the agent to return the "no data" error  (998)  when  it
   can't get data for a variable.

      +z

   This tells the agent to return a zero value for integers, or a null
   value for strings, when it can't get data for a variable. This will
   make it appear that all variables with valid instances exist.

KEYWORDS
   Snmpd accepts a few command-line arguments in keyword=value format.

      PORT=<number>

   This is another way to specify the SNMP port number. The default is
   161.  See SNMP_PORT below for more information.

      TRAP=<number>

   This specifies an SNMP TRAP port number.  The default is 162.   See
   SNMP_TRAP below for more information.

ENVIRONMENT
   Snmpd will use the following environment variables.  Note that some
   may be typed in two forms, with or without a '_'.

   ASN_FMT
     The format of the ASN.1 symbolic dumps produced at debug level  3
     and higher. The value is a single character, which may be any of:
       1    gives a single long line.
       2    puts each variable-value pair on a separate line.
       3    is fully indented, C-style, with each brace on a new line.
     The default is '2'. This may also be set in the agent.conf config
     file by a "asn-fmt:" line.

   BACKUP
     This tells the agent how to back up its  logfile.   The  simplest
     value is a number: "setenv BACKUP .3" will cause it to make up to
     three backup files when the size limit is hit; the  backups  will
     have ".1", ".2" and ".3" appended to their names.

   DBG_SIZE
     This is the size limit for the debug/audit/log file.  The default
     is  1000000  (one  million)  bytes,  after which the file will be
     renamed to a backup and a new logfile will be started.

   CM_HOST CMHOST
     This is the hostname to be used to get the IP address  where  the
     CM process is running; the default is "localhost".

   CM_PORT CMPORT
     This is the TCP/UDP port number for the CM; the default is 6010.

   CM_TCP CMTCP
     This is the TCP port number for the CM; the default is 6010.

   CM_UDP CMUDP
     This is the UDP port number for the CM; the default is 6010.

   CM_WAIT CMWAIT
     If defined, this will be used as the timeout in a  select()  call
     just after sending a message to the CM.  If undefined, snmpd will
     send the message and go about its business, checking occasionally
     for  a  reply.   This  is  the  preferred  behavior except during
     testing, and use of this variable is discouraged outside the lab.

   HEX_FMT
     The format of hexdumps produced at debug level 3 and higher.  The
     value is a single character, which may be any of:
       3Vv  mean a 3-line "vertical" dump (the most readable).
       2Hh  mean a 2-line dump (which makes cut-and-paste easy)
       1    is the IBM-style single-line format, the least readable.
     The default is '3'. This may also be set in the agent.conf config
     file by a "hex-fmt:" line.

   MIBFILE
     This should be the name of a file that contains the symbolic  MIB
     for the agent. It isn't actually used by snmpd, but it is used by
     various SNMP test programs for displaying replies. We describe it
     here for completeness.

   PID_FILE PIDFILE
     The process id of the snmpd program will be written to this file,
     which is "snmpd.pid" by default.

   SNMP_CONF SNMPCONF
     This is the name of the SNMP config file. The default config file
     is described below in the CONFIG FILE section.

   SNMP_DROP SNMPDROP
     This is the number of seconds that snmpd will keep a request.  If
     the  data  can't  be  found within that time, the message will be
     silently discarded.

   SNMP_HOST SNMPHOST
     This is the hostname to use when binding  to  a  UDP  port.   The
     default  is  to  use  a "wildcard" so that it can accept messages
     from all of the local machine's UDP ports.  This is mostly useful
     during  testing,  so  that  several  copies  of  snmpd may be run
     simultaneously (on `hostname` and "localhost").

   SNMP_MAX SNMPMAX
     This is the maximum size of an SNMP message. The default for this
     version of snmpd is 1500, which is greater than the official SNMP
     maximum  of  484  octets.   For  local  communication,  any  size
     supported  by the kernel may be used; for remote agents, use of a
     size greater than the MTU of any intervening interface may result
     in loss of messages when the network is congested.

   SNMP_POLL SNMPPOLL
     How long (in seconds) CM data is kept; when a variable gets to be
     this  old, a request for the data will trigger another CM request
     for the record that contains the variable's data.  The default is
     10 seconds.

   SNMP_PORT SNMPPORT
     This is the UDP port to use for SNMP requests.   The  default  is
     161. This is mostly useful in testing. Note that port 161 is only
     available to a super-user; during  testing,  you  probably  don't
     want  to  run with super-user permissions, so you must use a port
     number > 1023.

   SNMP_QUEUE SNMPQUEUE
     This is the maximum number of messages  allowed  in  the  agent's
     message  queue.   The default is 50.  If there are more that this
     many SNMP requests outstanding at  any  time,  incoming  messages
     will be dropped.

   SNMP_TRAP SNMPTRAP
     This  is the UDP port to use for SNMP TRAP messages.  The default
     is 162.  The remarks for SNMP_PORT apply here also.

INETD

   This version of snmpd may be started by inetd; it  understands  how
   inetd  starts  network services and cooperates.  To make this work,
   you should put a line into /etc/inetd.conf like:
      snmp dgram udp wait nm /etc/snmpd
   Actually, it's probably better to have inetd start a script so  you
   can set up snmpd's environment.  A suggested approach is to use the
   line:
      snmp dgram udp wait nm /etc/snmp
   and make /etc/snmp a script that ends with
      exec $D/snmpd
   where $D is the directory in which snmpd is installed. There should
   be a script called "snmp" accompanying this program; you might look
   at it for ideas (or just install it as /etc/snmp).

CONFIG FILE

   Most of snmpd's parameters may be set in its config file, which  may
	have any of several names.  The preferred 
   "agent.conf" (in "." or "/etc") by default; it can be named via the
   SNMPD_CONF environment variable. The modification time of this file
   is  checked  occasionally  (every 10 sec) by snmpd, and if the file
   changes, snmpd rereads it.  The general syntax of an entry  in  the
   config file is:
      parameter:  value # comment

   You may use '#' anywhere (outside of quotes) to cause the rest of
   the line to be ignored.

   For parameters with string values, you may  use  single  or  double
   quotes. If you omit the quotes, the value will be the string before
   the first space or '#' on the line.  Thus single words need not  be
   quoted;  quotes  are  needed if there are special characters within
   the value, or if you want a null string as the value.  If in doubt,
   use quotes.

   Here are (some of) the parameters recognized by snmpd  at  present.
   New  items  may  be added to this list at any time, so there may be
   some that aren't yet documented.  Unrecognized lines will produce a
   warning  message  in  the logfile, but are harmless.  Note that the
   format is quite similar to other SNMP agents'  config-file  formats
   (especially HP's OpenLook, which is used within GTE), so you may be
   able to use config files from other agents.

   debug: 4/tmp/snmpd.log # Debug level and name.

      This sets the debug  level  to  4  and  the  output  logfile  to
      "tmp/snmpd.log"  Note  that  when snmpd rereads the config file,
      this line will cause it to close the logfile and open a new one.

   backup: .3

      This tells snmpd to respond to logfile-full  (see  the  DBG_SIZE
      environment variable above) by renaming the logfile by appending
      a '.' and a digit; up to 3 such backups will be made,  and  then
      the older logfiles will be lost.

   env: NAME=value

      This adds NAME to the agent's environment list  with  the  given
      string  as  its  value.   Putting  this  in the config file will
      override the value passed in to the agent during startup (or  an
      earlier value from the config file).

   opt: <string>

      This treats the <string> as a command-line option. This lets you
      re-define  any of the command-line options by editing the config
      file.  Thus "opt:  -NXTpvc" will disable the GET-NEXT  operation
      for  swpvc variables.  "opt:  +m" will produce a new dump of the
      MIB table every time the config file is read.

   asn-fmt: 2     # ASN-dump format may be 1, 2 or 3.
   hex-fmt: 2     # Hex-dump format may be 1, 2 or 3.

      These define the formats of hex dumps at debug level 4  and  and
      higher,  and  symbolic  dumps  of ASN.1 (i.e., SNMP) messages at
      debug level 3 and higher.  The number is (roughly) the number of
      lines  that  are  produced.   See  the above descriptions of the
      ASN_FMT and HEX_FMT environment variables.

   get-community-name: SPANet
   get-community-addr: 192.9.55.0
   get-community-mask: 0xFF000000

      These define an acceptable community string in SNMP GET requests
      and optionally a range of source addresses. If the addr and mask
      are defined, then the mask is anded with the  get-community-addr
      and the source IP address of a request, and if they don't match,
      the request is ignored.  This example will accept  GET  requests
      with  the community string "SPANet" from any IP address with 192
      in its high-order byte.

   set-community-name: 'GTE SPANet'
   set-community-addr:  192.9.200.36
   set-community-mask:  0xFFFFFF00

      These define an acceptable community string in SNMP SET requests
      and optionally a range of source addresses. If the addr and mask
      are defined, then the mask is anded with the source  IP  address
      of  a  request  and  the  set-community-addr,  and if they don't
      match, the set request is ignored.

   set-community-name: 'gbs0.GTE.com'
   get-community-name: 'gbs0.GTE.com'
   set-community-addr: 192.9.200.1
   set-community-mask: 0xFFFFFFFF

      This shows how one might define a community string  that  allows
      get and set requests from exactly one specific IP address.

   cm-host: gbs35   # Hostname for CM.

      This says where the CM process is running; the default is on the
      local machine on which snmpd is running.

   queue-len: 100   # Message queue limit.
      
      This is the maximum number of messages that the agent will  hold
      in its queue; the default is 50. When the queue is full, any new
      SNMP requests will be dropped.  The value  1  will  restore  the
      original one-message-at-a-time behavior.

   trap-dest: 127.0.0.1

      This tells snmpd to send SNMP TRAP messages to the address.

   trap-dest: gbs35
   trap-comm: "GTE SPANet" # This needs to be quoted.

      This adds another TRAP destination to the list, and tells snmpd
      which community string to include in the messages.

   exit: 5

      The agent will exit with this status. This is most useful during
      testing,  as  a  way to tell snmpd to quit if you don't have the
      right permissions to use a "kill" command.  As long as this line
      is in the config file, any new snmpd that starts will exit. Then
      removing (or commenting out) the line will re-enable snmpd.

FILES

   /dev/kmem
      To implement the SNMP MIB, this program must  be  able  to  read
      from /dev/kmem. The conventional setup is: /dev/kmem is owned by
      the kmem group, and the user id used for testing must be in  the
      kmem group.  Alternatively, you can make snmpd setgid-kmem.

   agent.conf /etc/agent.conf
      This file is read (if either name exists and is readable) for an
      assortment of values.  Actually, these are the default names for
      the config file; if SNMP_CONF is defined in the environment,  it
      will be used for the file name.

   snmp.addr
      The agent writes its IP address and port number to this file, as
      a 5-number dotted-decimal ASCII string.

   snmp.pid
      The agent writes its process id number in ASCII to this file.

   snmp.port
      The agent writes its UDP port number in ASCII to this file. This
      is the same as the last field in snmpd.addr.

   The following files will be used for values  of  the  corresponding
   SNMP MIB variables:
     sysContact   (default is null)
     sysDescr     (default is from utsname)
     sysLocation  (default is null)
     sysName      (default is the hostname)

   The following files will be used for values  of  the  corresponding
   SPANet MIB variables:
     ndCurrAssociate (default is 0)
     ndNodeName      (default is the hostname)
     ndReqAssociate  (default is 0)
     ndSiteID        (default is null)
     ndSiteName      (default is null)

   In addition, the following files are read to determine  the  values
   of  the  corresponding  SPANet  MIB  variables.  For any that don't
   exist, the default value will be chosen.  Eventually we may have a
   way for the agent to learn these values from the CM.
     file       default
     ---------- -------
     swNumCM          1
     swNumEIM        32
     swNumEIMPT      16
     swNumICC         8
     swNumSFM        32
     swNumSFMPT      16

LOGFILE
DEBUGGING
   This agent has an extensive logfile capability built  in,  via  the
   dbg package. To enable logging, you may use a command-line argument
   or an environment variable.  The environment variable is:
      setenv D_snmpd <l><file>
   where <l> is a one-digit debug/verbose level,  and  <file>  is  the
   name of the output file.  For example:
      setenv D_snmpd 4/tmp/snmpd.log
   will  cause  snmpd  to run at debug level 4, and its output will be
   written to /tmp/snmpd.log.  If you prefer  to  use  a  command-line
   option, you may start snmpd via a command like:
      snmpd -D5/usr/adm/snmpd.log &
   This  will  start snmpd at debug level 5, and its output will go to
   the snmpd.log file in /usr/adm.

   Under normal circumstances, snmpd should run at debug level 1.   If
   there  are  problems with SNMP, level 2 will give error and warning
   messages.   In  an  initial  installation,  when  you   want   some
   verification  of what SNMP messages are being sent, you may want to
   use levels 3 or 4 to see the contents of the  messages.   Here  are
   what the debug levels mean:
     0 Silent.
     1 Serious or fatal error messages.
     2 Message times; less serious warnings.
     3 Symbolic dumps of messages.
     4 Hex dumps of messages; some details of data routines.
     5 and up - only useful if you have the source.

   If snmpd receives a CONT signal, the output logfile will be  closed
   and reopened. You may use this after deleting or renaming the file,
   to get a new (empty) log file.

SEE ALSO
   syslog(8), variables(5), RFC 1065, RFC 1066, RFC 1067

BUGS
   This agent can't be started by inetd.  It will attempt to open  the
   SNMP port, and will find that it is already in use.

AUTHOR
   John Chambers
