
SNMPSTATUS(1)            USER COMMANDS              SNMPSTATUS(1)

NAME
   snmpstatus - Retrieves important information from a network entity.

SYNOPSIS
   snmpstatus host [community]

DESCRIPTION
   Snmpstatus is an SNMP application that retrieves several  important
   statistics from a network entity.
 
   The  host  specification  may  be either a host name or an internet
   address specified in "dot notation"
 
   The community specifies the community name for the transaction with
   the  remote  system.   If this argument is not given, the community
   name will default to public .

   The information returned is:

   The IP address of the entity.
   A textual description of the entity (sysDescr.0)
   The uptime of the entity (sysUpTime.0)
   The sum  of  received  packets  on  all  interfaces  (ifInU-
   CastPkts.* + ifInNUCastPkts.*)
   The sum of transmitted packets on  all  interfaces  (ifOutU-
   CastPkts.* + ifOutNUCastPkts.*)
   The number of IP input packets (ipInReceives.0)
   The number of IP output packets (ipOutRequests.0)

   For example

   snmpstatus netdev-kbox.cc.cmu.edu public

   will produce output similar to the following:

   [128.2.56.220]=>[Kinetics FastPath2] Up: 1 day, 4:43:31
   IF recv/trans packets 262874/39867 | IP  recv/trans  packets
   31603/15805

   Snmpstatus  also  checks  the  operational status of all interfaces
   (ifOpStatus.*), and if it finds any that are not running, it will
   report in a manner similar to this:
 
   2 interfaces are down!
 
   The  host  specification  may  be either a host name or an internet
   address specified in "dot nota- tion"
 
   The community specifies the community name for the transaction with
   the remote system. If none is given, the community name defaults to
   public .
 
   If the network entity has an error processing the  request  packet,
   an  error  packet  will  be  returned  and a message will be shown,
   helping  to  pinpoint  in  what  way  the  request  was  malformed.
   Snmpstatus  will  attempt  to  reform it's request to eliminate the
   malformed variable, but this variable will then be missing from the
   displayed data.
 
   Adding  a  "-d"  to the argument list will cause the application to
   dump input and output packets.
 
SEE ALSO
   RFC 1065, RFC 1066, RFC 1067
