# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
#    $v = &fetchi(file,default);                                              #
# Read one number from one file.  If no number is found, the second arg  will #
# be used as the default.  Is there an elegant way to do this in perl? If so, #
# let us know about it.                                                       #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub fetchi {
	local($file,$val) = @_;
	local($l);
	if (open(X,"<$file")) {
line:	while ($l = <X>) {
			if ($l =~ /([-+]*[.\d]+)/) {
				$val = $1;
				last line;
			}
		}
		close X;
	} else {
		print STDERR "# $$: Can't read $file [$!]\n" if $dbg > 1;
	}
	$val;
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
#    $v = &fetchs(file,default);                                              #
# Read one line from one file.  Lines that start with '#' are  ignored.   Any #
# final  white  space will be trimmed.  Is there an elegant way to do this in #
# perl?  If so, let us know about it.                                         #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub fetchs {
	local($file,$val) = @_;
	local($l);
	if (open(X,"<$file")) {
line:	while ($l = <X>) {
			next line if ($l =~ /^#/);
			($val = $l) =~ s/\s*$//;;
			last line;
		}
		close X;
	} else {
		print STDERR "# $$: Can't read $file [$!]\n" if $dbg > 1;
	}
	$val;
}
1;
