# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Here are some things that are  potentially  needed  by  all  the  NDC  wish #
# scripts  to make them work right.  Your script should "source startup.w" as #
# one of its first actions.                                                   #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #

# First, set myname to the tcl name of this script, and me to the first field
# of  the  name.  These names will differ if there are multiple copies of the
# script running.
set me [lindex [set myname [winfo name .]] 0]

# Next, some global things used by lots of NDC wish scripts.  The environment
# variables are:
#   env(B_$me)  border width during testing, usually zero.
#   env(D_$me)  debug level, usually zero.
#   env(F_$me)  frame border width, usually 3.
#   env(R_$me)  relief, usually "ridge".
if [info exists env(B_$me)] {set B $env(B_$me)} else {set B 0}
if [info exists env(D_$me)] {set D $env(D_$me)} else {set D 0}
if [info exists env(F_$me)] {set F $env(F_$me)} else {set F 3}
if [info exists env(R_$me)] {set R $env(R_$me)} else {set R ridge}

source colors.w	;# NDC color palette routines.
LoadColors			;# Fill in the C() color array.
source Help.w		;# Help window routines.

# Extract things from the environment, or use defaults:
if [info exists env(NDCDIR)]     {set ndcdir  $env(NDCDIR)}     else {set ndcdir  "/ndc"}
if [info exists env(NDCLOGDIR)]  {set logdir  $env(NDCLOGDIR)}  else {set logdir  "$ndcdir/log"}
if [info exists env(NDCMONDIR)]  {set mondir  $env(NDCMONDIR)}  else {set mondir  "$ndcdir/mon"}
if [info exists env(NDCSNMPDIR)] {set snmpdir $env(NDCSNMPDIR)} else {set snmpdir "$ndcdir/snmp"}

# Make sure some things are in the environment, for subprocesses:
set env(NDCDIR)     $ndcdir
set env(NDCLOGDIR)  $logdir
set env(NDCMONDIR)  $mondir
set env(NDCSNMPDIR) $snmpdir
set env(PATH) .:/ndc/mon:/ndc/bin:/ndc/sh:/usr/OV/bin:$env(PATH)
#et env(SNMP_PORT)  6161
#et env(TRAP_PORT)  6162

# Some things that a few scripts need:
set colordir color
set   mapdir map
set  linkdir link

# Let's give this a try:
#tk_focusFollowsMouse
