# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
#   &store(file,line);                                                        #
# Write  one  line  to one file.  Is there an elegant way to do this in perl, #
# akin to sh's "echo $line > $file"? If so, let us know about it.  Note that, #
# with  $dbg  true, we show the file name and error message if we can't write #
# the file.  There is no meaningful return value.                             #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub store {
	local($file,$line) = @_;
	if (open(X,">$file")) {
		print X $line;
		close X;
		print STDOUT "# $0: Wrote $file: $line\n" if $dbg;
	} else {
		print STDOUT "# $0: Can't write $file [$!]\n" if $dbg;
		print STDERR "# $0: Can't write $file [$!]\n";
	}
}
1;
