
NAME
   style option - snmpGet snmpGetnext snmpwalk snmptest

SYNOPSIS
   snmpcmd -s<c> agent community variable..

DESCRIPTION
   The SNMP test programs  snmpGet  snmpGetnext  snmpwalk  (and  their
   alter  egos  Get  Next  and  Walk) all accept a "style" option that
   consists of "-s" or  "+s"  followed  by  a  single  character  that
   selects  one  of  a  set  of output styles.  There are four numeric
   styles (0-3) that specify various levels of  wordiness,  where  -s0
   means  "just the values" and -s3 means to be very gabby.  There are
   also three letter styles:  -sd gives DView-compatible  output;  -st
   gives tcl set commands, and -sw gives wish set commands.

EXAMPLES

   The -s1 option is the default, and gives just the  variable  names,
   any index (instance) values, and the value. Indexes are produced in
   the usual SNMP dotted-decimal notation.

      % snmpGetnext -s1 gbs35 public ifNumber ifOperStatus atIfIndex \
              sysName ifDescr ifPhysAddress
      ifNumber.0 2
      ifOperStatus.1 1
      atIfIndex.1.1.192.9.202.1 1
      sysName.0 "gbs35"
      ifDescr.1 "le0"
      ifPhysAddress.1 00 00 00 00 00 00

   The -s0 option gives only the values, with a  newline  after  each.
   This  is  of  limited  use,  since  the  caller  must KNOW what the
   variables are.

      % snmpGetnext -s0 gbs35 public ifNumber ifOperStatus atIfIndex \
              sysName ifDescr ifPhysAddress
      2
      1
      1
      gbs35
      le0
      00 00 00 00 00 00

   The -sd option gives output that has the variable  name,  a  space,
   the index values separated by commas, a space, and the value.  This
   format is meant to be easily parsable by sscanf().

      % snmpGetnext -sd gbs35 public ifNumber ifOperStatus atIfIndex \
              sysName ifDescr ifPhysAddress
      ifNumber 2
      ifOperStatus 1 1
      atIfIndex 1,1,192,9,202,1 1
      sysName "gbs35"
      ifDescr 1 "le0"
      ifPhysAddress 1  00:00:00:00:00:00

   The -st and -sw options give  tcl/wish  set  commands.   The  index
   values, if any, are within parentheses and separated by commas. The
   value is set off by a tab.

      % snmpGetnext -st gbs35 public ifNumber ifOperStatus atIfIndex \
              sysName ifDescr ifPhysAddress
      set ifNumber	2
      set ifOperStatus(1)	1
      set atIfIndex(1,1,192,9,202,1)	1
      set sysName	"gbs35"
      set ifDescr(1)	"le0"
      set ifPhysAddress(1)	00:00:00:00:00:00

SEE ALSO
   snmpGet.d, snmpGetnext.d, snmpwalk.d, snmptest.d

AUTHOR
  John Chambers 

